package com.chinamobile.xxjs.dios.bcm.client.api;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.chinamobile.xxjs.dios.bcm.client.api.IClientLoginService;
import com.chinamobile.xxjs.dios.bcm.client.api.IUniUserService;
import com.chinamobile.xxjs.dios.bcm.client.util.ServiceUrlPrefix;
import feign.Client;
import feign.Contract;
import feign.Feign;
import feign.Retryer;
import feign.codec.Decoder;
import feign.codec.Encoder;
import feign.jackson.JacksonDecoder;
import feign.jackson.JacksonEncoder;
import feign.okhttp.OkHttpClient;
import feign.spring.SpringContract;
import javax.annotation.Resource;
import okhttp3.OkHttpClient;
import org.springframework.context.annotation.Bean;

public class ApiConfiguration {
  @Resource
  private ServiceUrlPrefix serviceUrlPrefix;
  
  public <T> T buildFeignService(OkHttpClient httpClient, Class<T> type, String url) {
    return (T)Feign.builder()
      .client((Client)new OkHttpClient(httpClient))
      .contract((Contract)new SpringContract())
      .encoder((Encoder)new JacksonEncoder())
      .retryer(Retryer.NEVER_RETRY)
      .decoder((Decoder)new JacksonDecoder()).target(type, url);
  }
  
  @Bean
  IUniUserService uniUserService(OkHttpClient httpClient) {
    return buildFeignService(httpClient, IUniUserService.class, this.serviceUrlPrefix.getUserService());
  }
  
  @Bean
  IClientLoginService clientLoginService(OkHttpClient httpClient) {
    return buildFeignService(httpClient, IClientLoginService.class, this.serviceUrlPrefix.getClientLoginService());
  }
}
